=== debian/changelog ===
ltrmanager (1.5.1) stable; urgency=low

  * Initial Release.

 -- Borisov Alexey <borisov@lcard.ru>  Sat, 07 Apr 2012 11:35:15 +0400
