=== debian/control ===
Source: ltrmanager
Section: electronics
Priority: optional
Maintainer: Borisov Alexey <borisov@lcard.ru>
Build-Depends: debhelper (>= 8.0.0), cmake, libqt4-dev, libltrapi1-dev (>= 1.31.1)
Standards-Version: 3.9.3
Homepage: http://www.lcard.ru

Package: ltrmanager
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lboot
Replaces: qltrd
Suggests: ltrd
Description: Tool for monitoring and control LTR crates
 This is Qt GUI frontend for ltrd daemon which control L Card
 LTR-Crates. ltrmanager allows you control crate ethernet
 connection, log level, get crate list, etc.
