=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: electronics
 Priority: optional
 Maintainer: Borisov Alexey <borisov@lcard.ru>
-Build-Depends: debhelper (>= 8.0.0), cmake, libqt4-dev, libltrapi1-dev (>= 1.31.1)
+Build-Depends: debhelper (>= 8.0.0), cmake, qtbase5-dev, qttools5-dev, qttools5-dev-tools,  libltrapi1-dev (>= 1.32.7)
 Standards-Version: 3.9.3
 Homepage: http://www.lcard.ru
